precision highp float;

varying vec4 positionVarying;
varying vec2 texcoordVarying;

uniform vec4 texelIncrement;
uniform sampler2D screenTexture;

const vec2 leftTop   = vec2( -1, -1 );
const vec2 centerTop = vec2( 0, -1 );
const vec2 rightTop = vec2( 1, -1 );

const vec2 leftMiddle   = vec2( -1, 0 );
const vec2 rightMiddle = vec2( 1, 0 );

const vec2 leftBottom   = vec2( -1, 1 );
const vec2 centerBottom = vec2( 0, 1 );
const vec2 rightBottom = vec2( 1, 1 );

void main()
{
    float d = 0.0;
    vec4 color = texture2D(screenTexture, texcoordVarying);
//    vec2 uv;
//    uv = ;
//    vec4 tempColor = texture2D(screenTexture, leftTop * texelIncrement.xy );
    d += length( texture2D(screenTexture, leftTop * texelIncrement.xy + texcoordVarying ) - color );
    d += length( texture2D(screenTexture, centerTop * texelIncrement.xy + texcoordVarying ) - color );
    d += length( texture2D(screenTexture, rightTop * texelIncrement.xy + texcoordVarying ) - color );
    d += length( texture2D(screenTexture, leftMiddle * texelIncrement.xy + texcoordVarying ) - color );
    d += length( texture2D(screenTexture, rightMiddle * texelIncrement.xy + texcoordVarying ) - color );
    d += length( texture2D(screenTexture, leftBottom * texelIncrement.xy + texcoordVarying ) - color );
    d += length( texture2D(screenTexture, centerBottom * texelIncrement.xy + texcoordVarying ) - color );
    d += length( texture2D(screenTexture, rightBottom * texelIncrement.xy + texcoordVarying ) - color );
    d *= 15.9375; // 8개 평군( 0.125 ) * 길이값정규화( 0.5 ) * ( 색상 255 )
    float c0 = min( 1.0, smoothstep( 1.5, 5.0, d ) * 2.0 );
//    float c1 = smoothstep( 0.01, 0.25, d );
//    float c2 = smoothstep( 0.01, 0.5, d );
//    float c3 = smoothstep( 0.01, 0.75, d );
//    float c1 = smoothstep( 0.0, 0.5, d ) * 0.5;
//    c1 *= c1 * c1;
//    float c2 = smoothstep( 0.1, 0.2, d ) * 0.5;
//    float c3 = smoothstep( 0.01, 0.1, d ) * 0.5;
//    d = c0 * c0 + c1 * c1 + c2 * c2 + c3 * c3;
    d = ( c0 );
    gl_FragColor.rgb = vec3( 0.0, 0.0, 0.0 );
    gl_FragColor.a = d;
//    if( d > 1.0 )
//    {
//        gl_FragColor = vec4( 0.0, 0.0, 0.0, 1.0 );
//    }
//    else 
//    {
//        gl_FragColor = vec4( 0.0, 0.0, 0.0, 0.0 );
//    }
//    gl_FragColor = texture2D(screenTexture, texcoordVarying);
}