precision highp float;

attribute vec4 position;
attribute vec4 normal;

varying vec2 texcoordVarying;
varying vec4 diffuseVarying;
uniform mat4 mvp;
uniform vec4 viewport;

void main()
{
	texcoordVarying = normal.zw;

	// calculates labelcenter position
    diffuseVarying = vec4( 1.0, 1.0, 1.0, position.w );
    vec4 basePosition = vec4( position.x, position.y, position.z, 1.0 );
	basePosition = mvp * basePosition;
	basePosition /= basePosition.w;
	
	// calculates ndc space labelposition
	vec2 pixelOffsetBase = ( normal.xy / viewport.zw  ) * 2.0;
	gl_Position.x = basePosition.x + pixelOffsetBase.x;
	gl_Position.y = basePosition.y - pixelOffsetBase.y;
    gl_Position.zw = basePosition.zw;
}
