precision highp float;

varying vec3 v_position_world;
varying vec3 v_normal;

uniform vec4 u_diffuse_color;
uniform vec4 u_ambient_color;
uniform vec4 u_light_direction;

void main()
{
    vec3 norm = normalize(v_normal);
    vec3 lightDir = normalize(u_light_direction.xyz - v_position_world);
    float diff = clamp(dot(v_normal, lightDir), 0.0, 1.0);
    vec3 diffuse = diff * u_diffuse_color.xyz;
    
    gl_FragColor = vec4(diffuse + u_ambient_color.xyz, u_ambient_color.w);    
}
 
