#version 450

//attribute
layout (location = 0) in vec4 a_position;
layout (location = 1) in vec4 a_normal;

//varying
layout (location = 1) out vec2 v_texcoord;
layout (location = 7) out vec4 v_diffuse;

//uniform

layout (set = 0, binding = 0) uniform Block
{
    mat4 u_mvp;
    vec4 u_pixel_rotation;
    vec4 u_pixel_translation_scale;
    vec4 u_pixel_anchor;
    vec4 u_viewport;
} block;

vec3 rotate_vector( vec4 quat, vec3 vec )
{
	return vec + 2.0 * cross( cross( vec, quat.xyz ) + quat.w * vec, quat.xyz );
}

void main()
{
	v_texcoord = a_normal.zw;
	v_diffuse = vec4( 1.0, 1.0, 1.0, a_position.w );

       vec4 currentPosition = vec4( a_position.xyz, 1.0 );
	currentPosition = block.u_mvp * currentPosition;
	currentPosition /= currentPosition.w;

    vec3 translation = rotate_vector( block.u_pixel_rotation, vec3( a_normal.xy, 0.0) );
    translation.xy *= block.u_pixel_translation_scale.zw;

    translation += rotate_vector( block.u_pixel_rotation, vec3( block.u_pixel_anchor.xy, 0.0 ) );

    translation.xy += block.u_pixel_translation.xy;

	gl_Position.x = currentPosition.x + ( (translation.x ) / block.u_viewport.z ) * 2.0;
	gl_Position.y = currentPosition.y - ( (translation.y ) / block.u_viewport.w ) * 2.0;
    gl_Position.zw = currentPosition.zw;
}
