#version 450

//attribute
layout (location = 0) in vec4 a_position;
layout (location = 1) in vec4 a_normal;

//varying
layout (location = 1) out vec2 v_texcoord;
layout (location = 7) out vec4 v_diffuse;

//uniform
layout (set = 0, binding = 0) uniform Block
{
    mat4 u_mvp;
    vec4 u_view_scale;
} block;

const float uvWeight = 1.0 / 256.0;


void main()
{

    v_texcoord.x = ( a_normal.w + 128.5 ) * uvWeight;
    v_texcoord.y = 0.75;

    v_diffuse = vec4( 1.0, 1.0, 1.0, 1.0 );
    gl_Position = block.u_mvp * vec4( a_position.x, a_position.y, a_position.z * block.u_view_scale.z, 1.0 );
}
